---
title: Want-Digest
slug: Web/HTTP/Headers/Want-Digest
tags:
  - HTTP
  - HTTP Header
---
<div>{{HTTPSidebar}}</div>

<p>The <code><strong>Want-Digest</strong></code> HTTP header is primarily used in a HTTP request, to ask the responder to provide a {{Glossary("digest")}} of the requested resource using the <code><a href="/en-US/docs/Web/HTTP/Headers/Digest">Digest</a></code> response header.</p>

<p>The header contains identifiers for one or more digest algorithms that the sender wishes the responder to use to create the digest. The sender may use <a href="/en-US/docs/Glossary/Quality_values">quality values</a> to indicate its preference ordering among the choices it offers.</p>

<p>If <code>Want-Digest</code> does not include any digest algorithms that the server supports, the server may respond with:</p>

<ul>
 <li>a digest calculated using a different digest algorithm, or</li>
 <li>a <code><a href="/en-US/docs/Web/HTTP/Status/400">400 Bad Request</a></code> error, and include another <code>Want-Digest</code> header with that response, listing the algorithms that it does support.</li>
</ul>

<p>See the page for the <code><a href="/en-US/docs/Web/HTTP/Headers/Digest">Digest</a></code> header for more information.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("General header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Want-Digest: &lt;digest-algorithm&gt;

// Multiple algorithms, weighted with the quality value syntax:
Want-Digest: &lt;digest-algorithm&gt;&lt;q-value&gt;,&lt;digest-algorithm&gt;&lt;q-value&gt;</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt><code>&lt;digest-algorithm&gt;</code></dt>
 <dd>Supported digest algorithms are defined in <a href="https://tools.ietf.org/html/rfc3230">RFC 3230</a> and <a href="https://tools.ietf.org/html/rfc5843">RFC 5843</a>, and include <code>SHA-256</code> and <code>SHA-512</code>. Some of the supported algorithms, including <code>unixsum</code> and <code>MD5</code> are subject to collisions and are thus not suitable for applications in which collision-resistance is important.</dd>
 <dt><code>&lt;q-value&gt;</code></dt>
 <dd>The <a href="/en-US/docs/Glossary/Quality_values">quality value</a> to apply to that option.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="syntaxbox">Want-Digest: sha-256
Want-Digest: SHA-512;q=0.3, sha-256;q=1, md5;q=0</pre>

<h3 id="Basic_operation">Basic operation</h3>

<p>The sender provides a list of digests which it is prepared to accept, and the server uses one of them:</p>

<pre>Request:

  GET /item
  Want-Digest: sha-256;q=0.3, sha;q=1

Response:

  HTTP/1.1 200 Ok
  Digest: sha-256=X48E9qOokqqrvdts8nOJRJN3OWDUoyWxBf7kbu9DBPE=</pre>

<h3 id="Unsupported_digests">Unsupported digests</h3>

<p>The server does not support any of the requested digest algorithms, so uses a different algorithm:</p>

<pre>Request:

  GET /item
  Want-Digest: sha;q=1

Response:

  HTTP/1.1 200 Ok
  Digest: sha-256=X48E9qOokqqrvdts8nOJRJN3OWDUoyWxBf7kbu9DBPE=</pre>

<p>The server does not support any of the requested digest algorithms, so responds with a 400 error and includes another <code>Want-Digest</code> header, listing the algorithms that it does support:</p>

<pre>Request:

  GET /item
  Want-Digest: sha;q=1

Response:

  HTTP/1.1 400 Bad Request
  Want-Digest: sha-256, sha-512</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>
    <p><a class="smpl" href="https://datatracker.ietf.org/doc/draft-ietf-httpbis-digest-headers">draft-ietf-httpbis-digest-headers-latest</a></p>
   </td>
   <td>Resource Digests for HTTP</td>
  </tr>
 </tbody>
</table>

<p>This header was originally defined in <a href="https://tools.ietf.org/html/rfc3230">RFC 3230</a>, but the definition of "selected representation" in <a href="https://www.rfc-editor.org/info/rfc7231">RFC 7231</a> made the original definition inconsistent with current HTTP specifications. When released, The "Resource Digests for HTTP" draft therefore will obsolete RFC 3230 and will update the standard to be consistent.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.Want-Digest")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Digest")}}</li>
</ul>
